<?php 
class ControllerPaymentCzechPostCod extends Controller {
	private $error = array();
	
	public function install() {	
		$extensions = $this->model_setting_extension->getInstalled('shipping');
		
		if (!in_array('czechpost',$extensions)){
			$this->load->language('payment/czechpost_cod');
			$this->session->data['error'] = $this->language->get('error_install');
		}
	}
	 
	public function index() { 
		$this->load->language('payment/czechpost_cod');

		$this->document->setTitle($this->language->get('heading_title'));
		
		$this->load->model('setting/setting');
				
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('czechpost_cod', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');
			
			$this->redirect($this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'));
		}
		
		$this->data['heading_title'] = $this->language->get('heading_title');
		
		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');

		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');
		
		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');

		$this->data['tab_general'] = $this->language->get('tab_general');

 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}
		
		$this->data['action'] = $this->url->link('payment/czechpost_cod', 'token=' . $this->session->data['token'], 'SSL');

		$this->data['cancel'] = $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL');
		
		if (isset($this->request->post['czechpost_cod_status'])) {
			$this->data['czechpost_cod_status'] = $this->request->post['czechpost_cod_status'];
		} else {
			$this->data['czechpost_cod_status'] = $this->config->get('czechpost_cod_status');
		}
		
		if (isset($this->request->post['czechpost_cod_sort_order'])) {
			$this->data['czechpost_cod_sort_order'] = $this->request->post['czechpost_cod_sort_order'];
		} else {
			$this->data['czechpost_cod_sort_order'] = $this->config->get('czechpost_cod_sort_order');
		}
		
		$this->template = 'payment/czechpost_cod.tpl';
		$this->children = array(
			'common/header',
			'common/footer',
		);
				
		$this->response->setOutput($this->render());
	}
	
	private function validate() {
		if (!$this->user->hasPermission('modify', 'payment/czechpost_cod')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
				
		if (!$this->error) {
			return true;
		} else {
			return false;
		}	
	}
}
?>