<?php
class ControllerShippingCzechPost extends Controller {
	private $error = array();
	
	public function install() {
		$this->db->query("
		  CREATE TABLE IF NOT EXISTS " . DB_PREFIX . "cp_custom_service (
			  id int(11) NOT NULL AUTO_INCREMENT,
			  real_service_id int(11) NOT NULL,
			  cod_service_id int(11) NOT NULL,
			  price varchar(128) CHARACTER SET utf8 COLLATE utf8_czech_ci NOT NULL,
			  cod_price varchar(128) CHARACTER SET utf8 COLLATE utf8_czech_ci NOT NULL,
			  order_status_id int(11) NOT NULL,
			  sort_order int(11) NOT NULL,
			  geo_zone_id int(11) NOT NULL,
			  customer_group_id int(11) NOT NULL,
			  tax_class_id int(11) NOT NULL,
		  	  PRIMARY KEY (id)
		  ) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin");
		  
  		$this->db->query("
  		  CREATE TABLE IF NOT EXISTS " . DB_PREFIX . "cp_custom_service_description (
			  custom_service_id int(11) NOT NULL,
			  language_id int(11) NOT NULL,
			  name varchar(55) COLLATE utf8_bin NOT NULL,
			  description varchar(255) COLLATE utf8_bin NOT NULL,
			  PRIMARY KEY (custom_service_id, language_id)
		  ) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_bin");
		  
  		$this->db->query("
  		  CREATE TABLE IF NOT EXISTS " . DB_PREFIX . "cp_package2order (
			  id int(11) NOT NULL AUTO_INCREMENT,
			  order_id int(11) NOT NULL,
			  service varchar(5) COLLATE utf8_bin NOT NULL,
			  additional_service varchar(5) COLLATE utf8_bin NOT NULL,
			  cod varchar(5) COLLATE utf8_bin NOT NULL,
			  weight int(11) NOT NULL,
			  package_number varchar(32) COLLATE utf8_bin NOT NULL,
			  PRIMARY KEY (id)
		  ) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin");
	}
	
	public function uninstall() {
	   $this->db->query("DROP TABLE IF EXISTS " . DB_PREFIX . "cp_custom_service, " . DB_PREFIX . "cp_custom_service_description, " . DB_PREFIX . "cp_package2order ;");
	}
	
	public function index() {   
		$this->load->language('shipping/czechpost');

		$this->document->setTitle($this->language->get('heading_title'));
		
		$this->load->model('setting/setting');
				
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('czechpost', $this->request->post);		
					
			$this->session->data['success'] = $this->language->get('text_success');
						
			$this->redirect($this->url->link('shipping/czechpost', 'token=' . $this->session->data['token'], 'SSL'));
		}
				
		$this->data['heading_title'] = $this->language->get('heading_title');
		$this->data['heading_services'] = $this->language->get('heading_services');

		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_weight'] = $this->language->get('text_weight');
		$this->data['text_price'] = $this->language->get('text_price');
		$this->data['entry_calculate'] = $this->language->get('entry_calculate');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');
		
		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');
		$this->data['button_insert'] = $this->language->get('button_insert');
		
		$this->data['column_name'] = $this->language->get('column_name');
		$this->data['column_description'] = $this->language->get('column_description');
		$this->data['column_sort_order'] = $this->language->get('column_sort_order');
		$this->data['column_action'] = $this->language->get('column_action');
		
		$this->data['text_no_results'] = $this->language->get('text_no_results');

		$this->data['tab_general'] = $this->language->get('tab_general');

 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}

		if (isset($this->session->data['success'])) {
			$this->data['success'] = $this->session->data['success'];
		
			unset($this->session->data['success']);
		} else {
			$this->data['success'] = '';
		}
		
		/* Main settings */
		$this->data['action'] = $this->url->link('shipping/czechpost', 'token=' . $this->session->data['token'], 'SSL');
		
		$this->data['cancel'] = $this->url->link('extension/shipping', 'token=' . $this->session->data['token'], 'SSL');
		
		if (isset($this->request->post['czechpost_calculate'])) {
			$this->data['czechpost_calculate'] = $this->request->post['czechpost_calculate'];
		} else {
			$this->data['czechpost_calculate'] = $this->config->get('czechpost_calculate');
		}
		
		if (isset($this->request->post['czechpost_status'])) {
			$this->data['czechpost_status'] = $this->request->post['czechpost_status'];
		} else {
			$this->data['czechpost_status'] = $this->config->get('czechpost_status');
		}
		
		if (isset($this->request->post['czechpost_sort_order'])) {
			$this->data['czechpost_sort_order'] = $this->request->post['czechpost_sort_order'];
		} else {
			$this->data['czechpost_sort_order'] = $this->config->get('czechpost_sort_order');
		}				

		/* Custom services */
		$this->load->model('shipping/czechpost');
		
		$this->data['insert'] = $this->url->link('shipping/czechpost/insert', 'token=' . $this->session->data['token'], 'SSL');
		
		$this->data['custom_services'] = array();
		
		$results = $this->model_shipping_czechpost->getCustomServices();

		foreach ($results as $result) {
			$action = array();
			
			$action[] = array(
				'text' => $this->language->get('text_edit'),
				'href' => $this->url->link('shipping/czechpost/update', 'token=' . $this->session->data['token'] . '&custom_service_id=' . $result['custom_service_id'])
			);
			
			$action[] = array(
				'text' => $this->language->get('button_delete'),
				'href' => $this->url->link('shipping/czechpost/delete', 'token=' . $this->session->data['token'] . '&custom_service_id=' . $result['custom_service_id'])
			);			
			
			$this->data['custom_services'][] = array(
				'name'        		 => $result['name'],
				'description' 	 	 => $result['description'],
				'sort_order' 		 => $result['sort_order'],
				'action'     		 => $action
			);
			
		}
								
		$this->template = 'shipping/czechpost.tpl';
		$this->children = array(
			'common/header',
			'common/footer',
		);
				
		$this->response->setOutput($this->render());
	}

	public function insert() {
		$this->load->language('shipping/czechpost');
		
		$this->document->setTitle($this->language->get('heading_title_form'));
		
		$this->load->model('shipping/czechpost');
		
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {
			$this->model_shipping_czechpost->addCustomService($this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');
			
			$this->redirect($this->url->link('shipping/czechpost', 'token=' . $this->session->data['token'], 'SSL')); 
		}
	
    	$this->getForm();
	}
	
	public function update() {
    	$this->load->language('shipping/czechpost');

    	$this->document->setTitle($this->language->get('heading_title_form'));
		
		$this->load->model('shipping/czechpost');
	
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {
			$this->model_shipping_czechpost->editCustomService($this->request->get['custom_service_id'], $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');
			
			$this->redirect($this->url->link('shipping/czechpost', 'token=' . $this->session->data['token'], 'SSL')); 
		}

    	$this->getForm();
  	}
	
	public function delete() {
    	$this->load->language('shipping/czechpost');

    	$this->document->setTitle($this->language->get('heading_title_form'));
		
		$this->load->model('shipping/czechpost');
		
		if (($this->request->server['REQUEST_METHOD'] == 'GET') && $this->validateDelete()) {
			$this->model_shipping_czechpost->deleteCustomService($this->request->get['custom_service_id']);
			
			$this->session->data['success'] = $this->language->get('text_success');
			
			$this->redirect($this->url->link('shipping/czechpost', 'token=' . $this->session->data['token'] . $url, 'SSL'));
		}

    	$this->index();
  	}


	private function getForm() {
		$this->data['heading_title'] = $this->language->get('heading_title_form');

		$this->data['text_none'] = $this->language->get('text_none');
		$this->data['text_default'] = $this->language->get('text_default');
		$this->data['text_enabled'] = $this->language->get('text_enabled');
    	$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_all_zones'] = $this->language->get('text_all_zones');
		$this->data['text_all_groups'] = $this->language->get('text_all_groups');
		$this->data['text_guest_group'] = $this->language->get('text_guest_group');
				
		$this->data['entry_name'] = $this->language->get('entry_name');
		$this->data['entry_description'] = $this->language->get('entry_description');
		$this->data['entry_price'] = $this->language->get('entry_price');
		$this->data['entry_customer_group'] = $this->language->get('entry_customer_group');
		$this->data['entry_real_service'] = $this->language->get('entry_real_service');
		$this->data['entry_additional_service'] = $this->language->get('additional_service');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$this->data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$this->data['entry_customer_group'] = $this->language->get('entry_customer_group');
		$this->data['entry_tax'] = $this->language->get('entry_tax');
		$this->data['entry_real_service'] = $this->language->get('entry_real_service');
		$this->data['entry_cod_service'] = $this->language->get('entry_cod_service');
		$this->data['entry_cod_price'] = $this->language->get('entry_cod_price');
		$this->data['entry_order_status'] = $this->language->get('entry_order_status');	

		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');
		
		$this->data['tab_general'] = $this->language->get('tab_general');
    	$this->data['tab_data'] = $this->language->get('tab_data');
		$this->data['tab_cod'] = $this->language->get('tab_cod');
		
 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}
	
 		if (isset($this->error['name'])) {
			$this->data['error_name'] = $this->error['name'];
		} else {
			$this->data['error_name'] = array();
		}
		
   		if (isset($this->error['description'])) {
			$this->data['error_description'] = $this->error['description'];
		} else {
			$this->data['error_description'] = array();
		}
		
		if (!isset($this->request->get['custom_service_id'])) {
			$this->data['action'] = $this->url->link('shipping/czechpost/insert', 'token=' . $this->session->data['token'], 'SSL');
		} else {
			$this->data['action'] = $this->url->link('shipping/czechpost/update', 'token=' . $this->session->data['token'] . '&custom_service_id=' . $this->request->get['custom_service_id']);
		}
		
		$this->data['cancel'] = $this->url->link('shipping/czechpost', 'token=' . $this->session->data['token'], 'SSL');

		$this->data['token'] = $this->session->data['token'];

		if (isset($this->request->get['custom_service_id']) && ($this->request->server['REQUEST_METHOD'] != 'POST')) {
      		$custom_service_info = $this->model_shipping_czechpost->getCustomService($this->request->get['custom_service_id']);
    	}
		
		$this->load->model('localisation/language');
		
		$this->data['languages'] = $this->model_localisation_language->getLanguages();
		
		if (isset($this->request->post['custom_service_description'])) {
			$this->data['custom_service_description'] = $this->request->post['custom_service_description'];
		} elseif (isset($custom_service_info)) {
			$this->data['custom_service_description'] = $this->model_shipping_czechpost->getCustomServiceDescriptions($this->request->get['custom_service_id']);
		} else {
			$this->data['custom_service_description'] = array();
		}

    	if (isset($this->request->post['price'])) {
      		$this->data['price'] = $this->request->post['price'];
    	} else if (isset($custom_service_info)) {
			$this->data['price'] = $custom_service_info['price'];
		} else {
      		$this->data['price'] = '';
    	}
		
		$this->load->model('localisation/tax_class');

		$this->data['tax_classes'] = $this->model_localisation_tax_class->getTaxClasses();
		
		if (isset($this->request->post['tax_class_id'])) {
			$this->data['tax_class_id'] = $this->request->post['tax_class_id'];
		} elseif (isset($custom_service_info)) {
			$this->data['tax_class_id'] = $custom_service_info['tax_class_id'];
		} else {
			$this->data['tax_class_id'] = 0;
		}

		$this->data['real_services'] = $this->model_shipping_czechpost->getRealServices();
		
		if (isset($this->request->post['real_service_id'])) {
			$this->data['real_service_id'] = $this->request->post['real_service_id'];
		} elseif (isset($custom_service_info)) {
			$this->data['real_service_id'] = $custom_service_info['real_service_id'];
		} else {
			$this->data['real_service_id'] = 0;
		}
		
		$this->data['cod_services'] = $this->model_shipping_czechpost->getCoDServices();
		$this->data['cod_services'][-1] = array("name" => $this->data['text_disabled']);
		
		if (isset($this->request->post['cod_service_id'])) {
			$this->data['cod_service_id'] = $this->request->post['cod_service_id'];
		} elseif (isset($custom_service_info)) {
			$this->data['cod_service_id'] = $custom_service_info['cod_service_id'];
		} else {
			$this->data['cod_service_id'] = -1;
		}

		if (isset($this->request->post['cod_price'])) {
			$this->data['cod_price'] = $this->request->post['cod_price'];
		} elseif (isset($custom_service_info)) {
			$this->data['cod_price'] = $custom_service_info['cod_price'];
		} else {
			$this->data['cod_price'] = '';
		}

		$this->load->model('localisation/order_status');
		$this->data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
		
		if (isset($this->request->post['order_status_id'])) {
			$this->data['order_status_id'] = $this->request->post['order_status_id'];
		} elseif (isset($custom_service_info)) {
			$this->data['order_status_id'] = $custom_service_info['order_status_id'];
		} else {
			$this->data['order_status_id'] = $this->config->get('order_status_id'); 
		} 
		
		
		$this->load->model('sale/customer_group');
		
		$this->data['customer_groups'] = $this->model_sale_customer_group->getCustomerGroups();
		$this->data['customer_groups'][] = array('customer_group_id' => -1, 'name' => $this->data['text_all_groups']);
		$this->data['customer_groups'][] = array('customer_group_id' => -2, 'name' => $this->data['text_guest_group']);
		
		if (isset($this->request->post['customer_group_id'])) {
			$this->data['customer_group_id'] = $this->request->post['customer_group_id'];
		} elseif (isset($custom_service_info)) {
			$this->data['customer_group_id'] = $custom_service_info['customer_group_id'];
		} else {
			$this->data['customer_group_id'] = -1;
		}		
		
		$this->load->model('localisation/geo_zone');
		
		$this->data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if (isset($this->request->post['geo_zone_id'])) {
			$this->data['geo_zone_id'] = $this->request->post['geo_zone_id'];
		} elseif (isset($custom_service_info)) {
			$this->data['geo_zone_id'] = $custom_service_info['geo_zone_id'];
		} else {
			$this->data['geo_zone_id'] = $this->config->get('geo_zone_id');
		}

		if (isset($this->request->post['sort_order'])) {
			$this->data['sort_order'] = $this->request->post['sort_order'];
		} elseif (isset($custom_service_info)) {
			$this->data['sort_order'] = $custom_service_info['sort_order'];
		} else {
			$this->data['sort_order'] = 0;
		}


		$this->load->model('design/layout');
		
		$this->data['layouts'] = $this->model_design_layout->getLayouts();
						
		$this->template = 'shipping/czechpost_form.tpl';
		$this->children = array(
			'common/header',
			'common/footer',
		);
				
		$this->response->setOutput($this->render());
	}

	
	private function validate() {
		if (!$this->user->hasPermission('modify', 'shipping/czechpost')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		if (!$this->error) {
			return true;
		} else {
			return false;
		}	
	}
	
	private function validateForm() {
		if (!$this->user->hasPermission('modify', 'shipping/czechpost')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		foreach ($this->request->post['custom_service_description'] as $language_id => $value) {
			if ((strlen(utf8_decode($value['name'])) < 2) || (strlen(utf8_decode($value['name'])) > 255)) {
				$this->error['name'][$language_id] = $this->language->get('error_name');
			}
		}
		
		if ($this->error && !isset($this->error['warning'])) {
			$this->error['warning'] = $this->language->get('error_warning');
		}
					
		if (!$this->error) {
			return true;
		} else {
			return false;
		}
	}
	
  	private function validateDelete() {
    	if (!$this->user->hasPermission('modify', 'shipping/czechpost')) {
      		$this->error['warning'] = $this->language->get('error_permission');  
    	}
		
		if (!$this->error) {
	  		return true;
		} else {
	  		return false;
		}
  	}
}
?>