<?php 
class ModelShippingCzechPost extends Model {
	
	// Real services and CoD for export
	private $real_services = array(
		0 => array("name" => "Doporučený balíček", "code" => "BA", "additional_code" => "0"),
		1 => array("name" => "Cenný balík", "code" => "BB", "additional_code" => "0"),
		2 => array("name" => "Obchodní balík", "code" => "BO", "additional_code" => "0"),
		3 => array("name" => "EMS", "code" => "EE", "additional_code" => "0"),
		4 => array("name" => "Doporučená zásilka", "code" => "RR", "additional_code" => "50"),
	);
	
	private $cod_services = array(
		0 => array("name" => "Dobírka A", "additional_code" => "4"),
		1 => array("name" => "Dobírka C", "additional_code" => "5"),
		2 => array("name" => "Bezdokladová dobírka", "additional_code" => "41"),
	);
	
	public function getCustomServices() {
		$custom_services_data = array();
		
			$query = $this->db->query("SELECT cs.id, cs.sort_order, csd.name, csd.description  FROM " . DB_PREFIX . "cp_custom_service cs LEFT JOIN " . DB_PREFIX . "cp_custom_service_description csd ON (cs.id = csd.custom_service_id) WHERE csd.language_id = '" . (int)$this->config->get('config_language_id') . "' ORDER BY csd.name ASC");
		
			foreach ($query->rows as $result) {
				$custom_services_data[] = array(
					'custom_service_id' => $result['id'],
					'name'        		=> $result['name'],
					'description' 		=> $result['description'],
					'sort_order'  		=> $result['sort_order']
				);
			}	
			
		return $custom_services_data;
	}
	
	public function getCustomService($custom_service_id) {
		$query = $this->db->query("SELECT DISTINCT * FROM " . DB_PREFIX . "cp_custom_service cs LEFT JOIN " . DB_PREFIX . "cp_custom_service_description csd ON (cs.id = csd.custom_service_id) WHERE cs.id = '" . (int)$custom_service_id . "' AND csd.language_id = '" . (int)$this->config->get('config_language_id') . "'");
		
		return $query->row;
	}
	
	public function getCustomServiceDescriptions($custom_service_id) {
		$custom_service_description_data = array();
		
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "cp_custom_service_description WHERE custom_service_id = '" . (int)$custom_service_id . "'");
		
		foreach ($query->rows as $result) {
			$custom_service_description_data[$result['language_id']] = array(
				'name'             => $result['name'],
				'description'      => $result['description']
			);
		}
		
		return $custom_service_description_data;
	}
	
	public function getRealServices() {
		return $this->real_services;
	}
	
	public function getCoDServices() {
		return $this->cod_services;
	}
	
	public function addCustomService($data) {
		$this->db->query("INSERT INTO " . DB_PREFIX . "cp_custom_service SET real_service_id = '" . $this->db->escape($data['real_service_id']) . "', price = '" . $this->db->escape($data['price']) . "', cod_price = '" . $this->db->escape($data['cod_price']) . "', order_status_id = '" . $this->db->escape($data['order_status_id']) . "', sort_order = '" . $this->db->escape($data['sort_order']) . "', geo_zone_id = '" . (int)$data['geo_zone_id'] . "', customer_group_id = '" . (int)$data['customer_group_id'] . "', tax_class_id = '" . (int)$data['tax_class_id'] . "'");
		
		$custom_service_id = $this->db->getLastId();
		
		foreach ($data['custom_service_description'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "cp_custom_service_description SET custom_service_id = '" . (int)$custom_service_id . "', language_id = '" . (int)$language_id . "', name = '" . $this->db->escape($value['name']) . "', description = '" . $this->db->escape($value['description']) . "'");
		}
	}
	
	public function editCustomService($custom_service_id, $data) {
		$this->db->query("UPDATE " . DB_PREFIX . "cp_custom_service SET real_service_id = '" . $this->db->escape($data['real_service_id']) . "', price = '" . $this->db->escape($data['price']) . "', cod_price = '" . $this->db->escape($data['cod_price']) . "', order_status_id = '" . $this->db->escape($data['order_status_id']) . "', sort_order = '" . $this->db->escape($data['sort_order']) . "', geo_zone_id = '" . (int)$data['geo_zone_id'] . "', customer_group_id = '" . (int)$data['customer_group_id'] . "', tax_class_id = '" . (int)$data['tax_class_id'] . "' WHERE id = '" . (int)$custom_service_id . "'");
		
		$this->db->query("DELETE FROM " . DB_PREFIX . "cp_custom_service_description WHERE custom_service_id = '" . (int)$custom_service_id . "'");
		
		foreach ($data['custom_service_description'] as $language_id => $value) {
			$this->db->query("INSERT INTO " . DB_PREFIX . "cp_custom_service_description SET custom_service_id = '" . (int)$custom_service_id . "', language_id = '" . (int)$language_id . "', name = '" . $this->db->escape($value['name']) . "', description = '" . $this->db->escape($value['description']) . "'");
		}
	}
	
	public function deleteCustomService($custom_service_id) {
		$this->db->query("DELETE FROM " . DB_PREFIX . "cp_custom_service WHERE id = '" . (int)$custom_service_id . "'");
		$this->db->query("DELETE FROM " . DB_PREFIX . "cp_custom_service_description WHERE custom_service_id = '" . (int)$custom_service_id . "'");
	}

}
?>