<?php
class ModelShippingCzechPost extends Model {
	function getQuote($address) {
		$this->load->language('shipping/czechpost');
		
		if ($this->customer->isLogged()) {
			$group_id = $this->customer->getCustomerGroupId();
		} else {
			$group_id = '-2';
		}

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "cp_custom_service cs LEFT JOIN " . DB_PREFIX . "cp_custom_service_description csd ON (cs.id = csd.custom_service_id) WHERE (cs.customer_group_id = '" . (int)$group_id ."' OR cs.customer_group_id = '-1') AND csd.language_id = '" . (int)$this->config->get('config_language_id') . "' ORDER BY cs.sort_order ASC");

		$method_data = array();
      		
      	if ($query->rows) {
      		if ($this->config->get('czechpost_calculate') == '1' ) {
      			$calculate = $this->cart->getWeight();
      		} else {
      			$calculate = $this->cart->getSubTotal();
      		}

			$quote_data = array();
			
			foreach ($query->rows as $result) {
				if (!$result['geo_zone_id']) {
					$status = true;
				} else {
					$geo_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int)$result['geo_zone_id'] . "' AND country_id = '" . (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] . "' OR zone_id = '0')");
					if ($geo_query->num_rows) {
						$status = true;
					} else {
						$status = false;
					}	
				}
				
				if ($status) {
					$cost = null;
					$rates = explode(',', $result['price']);
			  		
			  		foreach ($rates as $rate) {
 		  				$data = explode(':', $rate);
			  				if ($data[0] >= $calculate) {
  								if (isset($data[1])) {
     								$cost = $data[1];
		  						}
 			  				break;
 				 		}
 				 	}
					
					if (!is_null($cost)) {
			      		$quote_data[$result['id']] = array(
			        		'code'         		=> 'czechpost.' . $result['id'],
			        		'title'        		=> $result['name'],
			        		'cost'        		=> $cost,
			        		'tax_class_id' 		=> $result['tax_class_id'],
							'text'         		=> $this->currency->format($this->tax->calculate($cost, $result['tax_class_id'], $this->config->get('config_tax'))),
							'description'		=> $result['description'],
							'real_service_id'	=> $result['real_service_id']
			      		);
					}
				}
			}
			
			if (!empty($quote_data)) {
		  		$method_data = array(
		    		'code'       => 'czechpost' ,
		    		'title'      => $this->language->get('text_title'),
		    		'quote'      => $quote_data,
					'sort_order' => $this->config->get('czechpost_sort_order'),
		    		'error'      => false
	  			);
			}
      	}	

		return $method_data;
	}
}
?>